# SCDAQ
Rudimentary data taking application for the CMS L1 scouting demonstrator

An RPM is built automatically by the CI pipeline and is stored as artifact of the "build" stage. **Important:** Once installed, the SCDAQ config file needs to be modified as described in the section below.

The RPM installs a systemd service that can be started with

```bash
$ sudo systemctl start runSCdaq
```

if SCDAQ should be automatically started at boot it can be enabled with

```bash
$ sudo systemctl enable runSCdaq
```

## Developing

We try to adhere to the [Google C++ style guide](https://google.github.io/styleguide/cppguide.html).

### Code formatting

The C++ code needs to follow the directives set forth in the `.clang-format` file placed in the repository root. This is enforced by the "check" stage of the CI.

You can format your code either with `clang-format -i [modified file]`, or (in particular for multiple changed files) with `git clang-format` after you have staged the modified files.

## Manual operation

### Build manually

**Use supplied Makefile to build:**

```
$ cd src
$ make
```

### Run manually

1. Start the run control on `scoutdaq`:
    ```
    $ cd scripts
    $ ./runControl.py
    ```

1. Start the data taking application on `scoutdaq`:
    ```
    $ cd scripts
    $ ./runSCdaq.sh -- config /etc/scdaq/scdaq.conf
    ```

## Configuration

By default the configuration file in `/etc/scdaq/scdaq.conf` is used. Examples of configuration files for various systems can be found in `/opt/scdaq/test/config/`.

## Compatibility

The MicronDMA option is designed for use with picocomputing-2021.2.7.

