#ifndef MICRONDMA_INPUT_FILER_H
#define MICRONDMA_INPUT_FILER_H

#include <micron_dma.h>

#include <memory>

#include "InputFilter.h"
#include "config.h"
#include "processor.h"

class MicronDmaInputFilter : public InputFilter {
 public:
  static bool firstRead;
  MicronDmaInputFilter(size_t, size_t, ctrl &, config &);
  virtual ~MicronDmaInputFilter();

 protected:
  ssize_t readInput(char **buffer, size_t bufferSize);  // Override
  void print(std::ostream &out) const;                  // Override
 private:
  micron_private *pico_;
  int stream2_;
  ssize_t runMicronDAQ(char **buffer);
  StreamProcessor::ProcessorType processorType_;
};
typedef std::shared_ptr<MicronDmaInputFilter> MicronDmaInputFilterPtr;

#endif  // MICRONDMA_INPUT_FILER_H
