#ifndef OUTPUTBYORBIT_H
#define OUTPUTBYORBIT_H

#include <stdint.h>

#include <cstdio>
#include <string>

#include "OutputFileHandler.h"
#include "slice.h"
#include "tbb/pipeline.h"

class ctrl;
class config;

//! Filter that writes each buffer to a file.
class OutputByOrbitStream : public tbb::filter {
 public:
  OutputByOrbitStream(ctrl &c, config &conf_);
  void *operator()(void *item) /*override*/;
  void OutputFixedOrbits(Slice &out);

 private:
  // used for fixed N orbits per file approach

  uint64_t totcounts_;
  ctrl &control_;
  config &conf_;
  OutputFileHandler output_file_handler_;
  size_t min_buffer_queue_size_;
};

#endif
